# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormExtValueSourceSearchResponseResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fqn': 'str',
        'result_type': 'FormserviceapiformsrendererexternalvaluesFieldType',
        'description': 'str',
        'input_parameters': 'list[FormExtValueSourceSearchResponseInputParameters]',
        'name': 'str',
        'category': 'str'
    }

    attribute_map = {
        'fqn': 'fqn',
        'result_type': 'resultType',
        'description': 'description',
        'input_parameters': 'inputParameters',
        'name': 'name',
        'category': 'category'
    }

    def __init__(self, fqn=None, result_type=None, description=None, input_parameters=None, name=None, category=None):  # noqa: E501
        """FormExtValueSourceSearchResponseResult - a model defined in Swagger"""  # noqa: E501
        self._fqn = None
        self._result_type = None
        self._description = None
        self._input_parameters = None
        self._name = None
        self._category = None
        self.discriminator = None
        if fqn is not None:
            self.fqn = fqn
        if result_type is not None:
            self.result_type = result_type
        if description is not None:
            self.description = description
        if input_parameters is not None:
            self.input_parameters = input_parameters
        if name is not None:
            self.name = name
        if category is not None:
            self.category = category

    @property
    def fqn(self):
        """Gets the fqn of this FormExtValueSourceSearchResponseResult.  # noqa: E501


        :return: The fqn of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :rtype: str
        """
        return self._fqn

    @fqn.setter
    def fqn(self, fqn):
        """Sets the fqn of this FormExtValueSourceSearchResponseResult.


        :param fqn: The fqn of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :type: str
        """

        self._fqn = fqn

    @property
    def result_type(self):
        """Gets the result_type of this FormExtValueSourceSearchResponseResult.  # noqa: E501


        :return: The result_type of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :rtype: FormserviceapiformsrendererexternalvaluesFieldType
        """
        return self._result_type

    @result_type.setter
    def result_type(self, result_type):
        """Sets the result_type of this FormExtValueSourceSearchResponseResult.


        :param result_type: The result_type of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :type: FormserviceapiformsrendererexternalvaluesFieldType
        """

        self._result_type = result_type

    @property
    def description(self):
        """Gets the description of this FormExtValueSourceSearchResponseResult.  # noqa: E501


        :return: The description of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FormExtValueSourceSearchResponseResult.


        :param description: The description of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def input_parameters(self):
        """Gets the input_parameters of this FormExtValueSourceSearchResponseResult.  # noqa: E501


        :return: The input_parameters of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :rtype: list[FormExtValueSourceSearchResponseInputParameters]
        """
        return self._input_parameters

    @input_parameters.setter
    def input_parameters(self, input_parameters):
        """Sets the input_parameters of this FormExtValueSourceSearchResponseResult.


        :param input_parameters: The input_parameters of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :type: list[FormExtValueSourceSearchResponseInputParameters]
        """

        self._input_parameters = input_parameters

    @property
    def name(self):
        """Gets the name of this FormExtValueSourceSearchResponseResult.  # noqa: E501


        :return: The name of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FormExtValueSourceSearchResponseResult.


        :param name: The name of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def category(self):
        """Gets the category of this FormExtValueSourceSearchResponseResult.  # noqa: E501


        :return: The category of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this FormExtValueSourceSearchResponseResult.


        :param category: The category of this FormExtValueSourceSearchResponseResult.  # noqa: E501
        :type: str
        """

        self._category = category

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormExtValueSourceSearchResponseResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormExtValueSourceSearchResponseResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
